                ;          "Find Search string S$"
7530 2A4B5C     FINDS LD   HL,(VARS)
7533 7E         NEXT1 LD   A,(HL)
7534 FE53             CP   "S"
7536 280E             JR   Z,GOT_S
7538 FE80             CP   T_END
753A 2806             JR   Z,ERROR
753C CDB819           CALL F_VAR
753F EB               EX   DE,HL
7540 18F1             JR   NEXT1
                ;
                ;          "Variable not found!"
7542 CF         ERROR RST  8
7543 01               DEFB 1
                ;          "Parameter error!"
                ;          "(Wrong string length)"
7544 CF         L_ERR RST  8
7545 19               DEFB 25
                ;
                ;          "HL points at name S$"
7546 23         GOT_S INC  HL
                ;          "Check length is >0"
7547 7E               LD   A,(HL)
7548 B7               OR   A
7549 28F9             JR   Z,L_ERR
754B 23               INC  HL
                ;          "Check length is <256"
754C 7E               LD   A,(HL)
754D B7               OR   A
754E 20F4             JR   NZ,L_ERR
7550 23               INC  HL
7551 E5               PUSH HL
                ;          "IX points at S$ text"
7552 DDE1             POP  IX
                ;
                ;          "Find replacement, R$"
                ;
7554 2A4B5C           LD   HL,(VARS)
7557 7E         NEXT2 LD   A,(HL)
7558 FE52             CP   "R"
755A 280A             JR   Z,GOT_R
755C FE80             CP   T_END
755E 28E2             JR   Z,ERROR
7560 CDB819           CALL F_VAR
7563 EB               EX   DE,HL
7564 18F1             JR   NEXT2
                ;          "HL points at name R$"
7566 23         GOT_R INC  HL
                ;          "R_LEN points at R$"
7567 22AE5C           LD   (R_LEN),HL
                ;          "Check length is <256"
756A 23               INC  HL
756B 7E               LD   A,(HL)
756C B7               OR   A
756D 20D5             JR   NZ,L_ERR
756F ED5B535C         LD   DE,(PROG)
7573 1B               DEC  DE
                ;
                ;          "**** MAIN SEARCH LOOP"
                ;
                ;          "Find length of line"
7574 13         LINE  INC  DE
7575 13               INC  DE
7576 13               INC  DE
7577 ED53AC5C         LD   (L_LEN),DE
757B 13               INC  DE
757C 13               INC  DE
757D D5         FIND  PUSH DE
                ;          "Get old data length &"
                ;          "point HL at old data"
757E DD46FE           LD   B,(IX-2)
7581 DDE5             PUSH IX
7583 E1               POP  HL
                ;          "Match B characters"
7584 1A         MATCH LD   A,(DE)
7585 BE               CP   (HL)
7586 2067             JR   NZ,GO_ON
7588 23               INC  HL
7589 13               INC  DE
758A 10F8             DJNZ MATCH
                ;          "Match found, work out"
                ;          "difference of lengths"
758C 2AAE5C           LD   HL,(R_LEN)
758F 7E               LD   A,(HL)
7590 DD96FE           SUB  (IX-2)
                ;          "A = extra bytes needed"
7593 2849             JR   Z,NO_OK
7595 302C             JR   NC,ADD_A
                ;
                ;          "Discard 256-A bytes"
                ;
7597 ED44             NEG
7599 4F               LD   C,A
                ;          "Line length=length-BC"
759A 2AAC5C           LD   HL,(L_LEN)
759D 5E               LD   E,(HL)
759E 23               INC  HL
759F 56               LD   D,(HL)
75A0 EB               EX   DE,HL
75A1 B7               OR   A
75A2 ED42             SBC  HL,BC
75A4 EB               EX   DE,HL
75A5 72               LD   (HL),D
75A6 2B               DEC  HL
75A7 73               LD   (HL),E
                ;          "Adjust R$, S$ pointers"
75A8 DDE5             PUSH IX
75AA E1               POP  HL
75AB ED42             SBC  HL,BC
75AD E5               PUSH HL
75AE DDE1             POP  IX
75B0 2AAE5C           LD   HL,(R_LEN)
75B3 ED42             SBC  HL,BC
75B5 22AE5C           LD   (R_LEN),HL
75B8 E1               POP  HL
                ;          "Shrink from start"
75B9 E5               PUSH HL
75BA CDE819           CALL SHRNK
75BD 181F             JR   NO_OK
                ;
                ;          "Extended jumps"
                ;
75BF 18BC       FINDX JR   FIND
75C1 18B1       LINEX JR   LINE
                ;
                ;          "Add A bytes"
                ;
75C3 4F         ADD_A LD   C,A
                ;          "Add BC to line length"
75C4 D5               PUSH DE
75C5 2AAC5C           LD   HL,(L_LEN)
75C8 5E               LD   E,(HL)
75C9 23               INC  HL
75CA 56               LD   D,(HL)
75CB EB               EX   DE,HL
75CC 09               ADD  HL,BC
75CD EB               EX   DE,HL
75CE 72               LD   (HL),D
75CF 2B               DEC  HL
75D0 73               LD   (HL),E
                ;          "Update S$, R$ pointers"
75D1 DD09             ADD  IX,BC
75D3 2AAE5C           LD   HL,(R_LEN)
75D6 09               ADD  HL,BC
75D7 22AE5C           LD   (R_LEN),HL
75DA E1               POP  HL
75DB CD5516           CALL XPAND
                ;
                ;          "Copy new data to prog"
                ;
75DE D1          NO_OK POP  DE
75DF 2AAE5C           LD   HL,(R_LEN)
75E2 0600             LD   B,0
75E4 4E               LD   C,(HL)
                ;          "Check R$ isn't empty"
75E5 79               LD   A,C
75E6 B7               OR   A
75E7 2808             JR   Z,NEXT
                ;          "Bounce HL past length"
75E9 23               INC  HL
75EA 23               INC  HL
75EB EDB0             LDIR
                ;          "Search on from (DE)"
75ED 1802             JR   NEXT
                ;
                ;          "Try the next position"
                ;
75EF D1         GO_ON POP  DE
75F0 13               INC  DE
                ;          "Check user isn't bored"
75F1 3E7F       NEXT  LD   A,127
75F3 DBFE             IN   A,(254)
75F5 1F               RRA
75F6 3802             JR   C,CONT
                ;          "Generate BREAK error!"
75F8 CF               RST  8
75F9 14               DEFB 20
                ;          "Locate end of program"
75FA 2A4B5C     CONT  LD   HL,(VARS)
75FD B7               OR   A
75FE ED52             SBC  HL,DE
                ;          "Return at end of prog"
7600 D8               RET  C
                ;          "Check for new line no."
7601 1A               LD   A,(DE)
7602 FE0D             CP   ENTER
7604 28BB             JR   Z,LINEX
                ;          "Don't scan hidden nums"
7606 FE0E             CP   NUMBR
7608 20B5             JR   NZ,FINDX
                ;          "Skip over the number"
760A 210600           LD   HL,6
760D 19               ADD  HL,DE
760E EB               EX   DE,HL
760F 18E9             JR   CONT
                      END
